---
title: Xamarin.Android error XA0000
description: XA0000 error code
ms.date: 03/29/2019
---
# Xamarin.Android error XA0000

## Issue

An unhandled exception (or error case) was encountered in one of
Xamarin.Android's MSBuild tasks.

## Solution

Consider submitting a [bug][bug] if you are getting this warning under
normal circumstances.

[bug]: https://github.com/xamarin/xamarin-android/wiki/Submitting-Bugs,-Feature-Requests,-and-Pull-Requests

## Specific scenario 1

### Issue

An exception was thrown and logged, including a C# exception stack
trace showing where the failure occurred.

### Solution

Likely, the only option is to submit a [bug][bug].

## Specific scenario 2

### Issue

You are using a `$(TargetFrameworkVersion)` which cannot be mapped
to a valid android api-level.

### Solution

Check you have selected a valid `$(TargetFrameworkVersion)` and the
required android api-level is installed in
*$(AndroidSdkDirectory)\\platforms*.
